﻿B4i=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.5
@EndOfDesignText@
Sub Class_Globals
	Private sendermodule As Object
	Private s_EventName As String
	Private bc As ByteConverter
	
	Private i_AnalyseBytes As Int = 4410 'every 50 ms = 1/20 = 44.100 / 20 = 2205 (16bit) so x2 for bytes = 4410
	Public i_BytesOffset As Int
	Private raf_Wave As RandomAccessFile 'Standard Wave PCM, 44 Bytes Header, 16 Bit Mono, SampleRate 44.100
	Private b_Data(i_AnalyseBytes) As Byte, i_Data(i_AnalyseBytes / 2) As Short 'Array for analyzing sound-data
	Private i_StartTime As Long 'for time testings
End Sub

Public Sub Initialize(module As Object, event As String)
	sendermodule = module
	s_EventName = event
	bc.LittleEndian = True
End Sub

Sub StartAnalysing(folder As String, recfile As String)
	raf_Wave.Initialize2(folder, recfile, True, True) 'Little Endian
End Sub

Sub SetOffsetBeforeEnd
	Dim iSize As Int = raf_Wave.Size
	Dim iPos As Int = iSize - i_AnalyseBytes 'to last (just recorded) samples
	If iPos < 0 Then iPos = 0
	i_BytesOffset = iPos
End Sub

Sub SetAnalyseData
	'Question here: what is the fastest way to get the just recorded short array?
	raf_Wave.ReadBytes(b_Data, 0, i_AnalyseBytes, i_BytesOffset)
	i_Data = bc.ShortsFromBytes(b_Data)
End Sub

Sub Analyse() As Double
	SetOffsetBeforeEnd
	SetAnalyseData
	Dim dRes As Double
	'analyzing ...
	
	Return dRes
End Sub

Sub StartTimer
	i_StartTime = DateTime.Now
End Sub

Sub EndTimer() As Int
	Dim iTime As Long = DateTime.Now - i_StartTime
	Return iTime
	
End Sub